<template>
	<div class="flex-1 flex flex-row my-2 items-center">
		<label :for="field.key" class="w-1/4">{{ field.label }}</label>
		<textarea :name="field.key" :id="field.key" rows="5" v-if="field.type === 'textarea'" @input.prevent="update"
				  class="flex-1 p-3 pl-4 bg-transparent border border-white duration-500
				hover:shadow_input_blue hover:border-blue focus:shadow_input_blue focus:border-blue">{{ currentSetting }}</textarea>
		<select :name="field.key" :id="field.key" v-else-if="field.type === 'select'" :value="currentSetting" @input.prevent="update"
				class="flex-1 p-3 pl-4 bg-transparent border border-white duration-500 appearance-none
				hover:shadow_input_blue hover:border-blue focus:shadow_input_blue focus:border-blue">
			<option :value="key" :key="key" v-for="(label, key) in field.options"> {{ label }}</option>
		</select>
		<input :id="field.key" :name="field.key" :type="field.type" :value="currentSetting" @input.prevent="update" v-else
			   class="flex-1 p-3 pl-4 bg-transparent border border-white duration-500
				hover:shadow_input_blue hover:border-blue focus:shadow_input_blue focus:border-blue" >
	</div>
</template>

<script>
import {mapMutations, mapState} from "vuex";

export default {
	name: "FormInput",
	props: {
		field: {
			type: Object,
			required: true,
			default: () => ({
				label: '',
				key: '',
				type: '',
			})
		}
	},
	computed: {
		...mapState('config', {
			currentSetting(state){
				return state.settings[this.field.key];
			}
		}),
	},
	methods: {
		...mapMutations('config', [
			'setting_set'
		]),
		update(e){
			let value = e.target.value;
			if(this.field.is_int){
				let n = Number.parseInt(value);
				value = Number.isNaN(n) ? 0 : n;
				this.$forceUpdate();
			}
			this.setting_set({
				key: this.field.key,
				value: value
			})
		}
	}
}
</script>

<style scoped>

</style>